/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUAGER                                                      */
/* Tabela : AREAGERE                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 10/10/2006 - Eduardo H. C. Ramos                                           */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATUAGER
BEFORE INSERT OR UPDATE OR DELETE
ON AREAGERE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUAGER := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDAREAGERE,0 ) <> NVL(:NEW.CDAREAGERE,0)) OR
         (NVL(:OLD.NMAREAGERE,0) <> NVL(:NEW.NMAREAGERE,0)) THEN
         :NEW.DTULTATUAGER := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('AREAGERE', '',         'CDAREAGERE='||:OLD.CDAREAGERE, SYSDATE);                  
   END IF;
END;
/

ALTER TABLE AREAGERE MODIFY DTULTATUAGER DEFAULT SYSDATE
/